function DupLines(Sender) {
  var Sel = Editor.Selection;
  if ((Sel.SelStartLine >= 0) && (Sel.SelEndLine >= 0)) {

    Editor.BeginEditing;

    var start = Sel.SelStartLine;
    var end = Sel.SelEndLine;
    if ((end > start) && (Sel.SelEndCol == 0)) {
      end--;
    }

    var line;
    var s = "";
    for (var f = start; f <= end; f++) {
      line = Editor.Lines[f];
      s += line + "\n";
    }

    Sel.SelStartLine = end + 1;
    Sel.SelStartCol = 0;
    Sel.SelEndLine = Sel.SelStartLine;
    Sel.SelEndCol = 0;
    Editor.Selection = Sel;
    Editor.SelText = s;

    Editor.EndEditing;
  }
}


Script.RegisterDocumentAction("", "Duplicate Selected Lines", "Ctrl+D", &DupLines);

